C Calculates the lattice parameter of enriched austenite, after a
C degree of transformation to ferrite.
C
      SUBROUTINE MAP_STEEL_PARAM2(AGTX,AGT,AAT,VA,XBAR,XALPHA,
     &                             XG,EXG,T,AV,RTEMP)
C
      IMPLICIT NONE
      DOUBLE PRECISION AAT,AGES,AGT,AGTX,AGTX1,AGTX2,AV,DIFF
      DOUBLE PRECISION EXG,RHOA,RHOG,RTEMP,T,VA
      DOUBLE PRECISION XALPHA,XBAR,XG
      INTEGER II
C
C  Guess a value AGES of AGTX and then iterate 
C  
      AGTX = AGT
      AGES = AGTX
C
C************************************************************
C Modified by Harsha
C************************************************************
C
      AGTX2 = AGT
  100 AGTX1 = AGTX2
C	
C A2 is the mole fraction of iron atoms in ferrite
C Make the approximation that density Rho depends only on atomic wt. of iron
C See p.58, Oak Ridge Book
C
      RHOA = 55.847*2.0/(AV*AAT*AAT*AAT*1.0D-30)
      RHOG = 55.847*4.0/(AV*AGTX1*AGTX1*AGTX1*1.0D-30)
      XG   = (VA*RHOA*(XBAR-XALPHA) + XBAR*RHOG*(1.0-VA))
     &        /((1.0-VA)*RHOG)
C
C XG is the wt% Carbon in the enriched austenite. 
C Note XBAR and XALPHA are in wt%.
C
C calculate new value of enriched austenite lattice parameter 
C
      AGTX2 = AGT+0.033*(XG-XBAR)*(1.0D+00 + (T-RTEMP)*EXG) 
      DIFF  = (AGTX1-AGTX2)/AGTX1
      DIFF  = DABS(DIFF)
C
C Check for Convergence of AGTX
C
      II = II+1
      IF (II .GT. 10D+10) THEN
         WRITE(*,1)
         STOP
      ENDIF
      IF (DIFF .GT. 1.0D-10) GOTO 100
      AGTX = AGTX2
      RETURN
    1 FORMAT(' *****************************'///
     &       '  TOO MANY ITERATION STEPS, Check DATA '///
     &       ' ******************************************')
      END

